//  yuv2nv12.h
//
//	YUV to NV12 converter
//
//	Copyright (c) 2005 N099
//

class Cyuv2nv12 : public CTransformFilter
{
private:
	LONG height;      // C[W̍
	LONG width_in;    // ̓C[W̕(XgChȂ)
	LONG width_in_s;  // ̓C[W̕(XgCh)
	LONG width_out;   // o̓C[W̕(XgChȂ)
	LONG width_out_s; // o̓C[W̕(XgCh)
	int format_in;    // ̓tH[}bg
	int interlace;    // C^[[X(t[Ƃ̃tO)
	CONFIG conf;
	CCritSec  m_cs;   // Lf[^ی삷

	//
	HRESULT CheckInterlace(IMediaSample *);
	void Convert(BYTE *, BYTE *, IMediaSample *);
	BITMAPINFOHEADER *GetBmiHeader(const CMediaType &) const;
	void CopySubsetVIF2Flag(VIDEOINFOHEADER2 *, const VIDEOINFOHEADER2 *) const;

public:
	DECLARE_IUNKNOWN;
	Cyuv2nv12(TCHAR *, LPUNKNOWN);
	HRESULT CheckInputType(const CMediaType *);
	HRESULT GetMediaType(int, CMediaType *);
	HRESULT CheckTransform(const CMediaType *, const CMediaType *);
	HRESULT DecideBufferSize(IMemAllocator *, ALLOCATOR_PROPERTIES *);
	HRESULT Transform(IMediaSample *, IMediaSample *);
	HRESULT CompleteConnect(PIN_DIRECTION, IPin *);
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN, HRESULT *);
};

